diff -ruN qmail-1.03-orig/read-ctrl.c qmail-1.03-ldap-20060201-orig/read-ctrl.c
--- qmail-1.03-orig/read-ctrl.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/read-ctrl.c	2006-02-25 11:00:56.000000000 +0100
@@ -0,0 +1,75 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <unistd.h>
+
+#include "auto_qmail.h"
+#include "control.h"
+#include "error.h"
+#include "open.h"
+
+#include "read-ctrl.h"
+
+/* TODO logging */
+int
+read_controls(ctrlfunc *f)
+{
+	int	i, fddir;
+	
+	fddir = open_read(".");
+	if (fddir == -1)
+		return -1;
+	if (chdir(auto_qmail) == -1)
+		return -1;
+	
+	if (control_init() == -1)
+		goto fail;
+	for (i = 0; f[i] != 0; i++) {
+		if (f[i]() == -1)
+			goto fail;
+	}
+
+	if (fchdir(fddir) == -1)
+		return -1;
+	close(fddir);
+	return 0;
+	
+fail:
+	i = errno;
+	if (fchdir(fddir) == -1)
+		return -1;
+	close(fddir);
+	errno = i;
+	return -1;
+}
+
diff -ruN qmail-1.03-orig/read-ctrl.h qmail-1.03-ldap-20060201-orig/read-ctrl.h
--- qmail-1.03-orig/read-ctrl.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/read-ctrl.h	2006-02-25 11:00:56.000000000 +0100
@@ -0,0 +1,41 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef __READ_CTRL_H__
+#define __READ_CTRL_H__
+
+typedef int (*ctrlfunc)(void);
+
+int read_controls(ctrlfunc *);
+
+#endif
diff -ruN qmail-1.03-orig/readsubdir.c qmail-1.03-ldap-20060201-orig/readsubdir.c
--- qmail-1.03-orig/readsubdir.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/readsubdir.c	2006-02-25 11:00:56.000000000 +0100
@@ -6,7 +6,7 @@
 
 void readsubdir_init(rs,name,pause)
 readsubdir *rs;
-char *name;
+const char *name;
 void (*pause)();
 {
  rs->name = name;
@@ -31,7 +31,7 @@
    len = 0;
    len += fmt_str(namepos + len,rs->name);
    namepos[len++] = '/';
-   len += fmt_ulong(namepos + len,(unsigned long) rs->pos);
+   len += fmt_uint(namepos + len, rs->pos);
    namepos[len] = 0;
    while (!(rs->dir = opendir(namepos))) rs->pause(namepos);
    rs->pos++;
diff -ruN qmail-1.03-orig/readsubdir.h qmail-1.03-ldap-20060201-orig/readsubdir.h
--- qmail-1.03-orig/readsubdir.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/readsubdir.h	2006-02-25 11:00:56.000000000 +0100
@@ -6,14 +6,14 @@
 typedef struct readsubdir
  {
   DIR *dir;
-  int pos;
-  char *name;
+  unsigned int pos;
+  const char *name;
   void (*pause)();
  }
 readsubdir;
 
-extern void readsubdir_init();
-extern int readsubdir_next();
+extern void readsubdir_init(readsubdir *, const char *, void (*)());
+extern int readsubdir_next(readsubdir *, unsigned long *);
 
 #define READSUBDIR_NAMELEN 10
 
diff -ruN qmail-1.03-orig/readwrite.c qmail-1.03-ldap-20060201-orig/readwrite.c
--- qmail-1.03-orig/readwrite.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/readwrite.c	2006-02-25 11:00:56.000000000 +0100
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <sys/types.h>
+#include <unistd.h>
+
+#include "readwrite.h"
+
+int
+subread(int fd, void *buf, int size)
+{
+	return (int)read(fd, buf, size);
+}
+
+int
+subwrite(int fd, void *buf, int size)
+{
+	return (int)write(fd, buf, size);
+}
+
diff -ruN qmail-1.03-orig/readwrite.h qmail-1.03-ldap-20060201-orig/readwrite.h
--- qmail-1.03-orig/readwrite.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/readwrite.h	2006-02-25 11:00:56.000000000 +0100
@@ -1,7 +1,7 @@
 #ifndef READWRITE_H
 #define READWRITE_H
 
-extern int read();
-extern int write();
+int subread(int, void *, int);
+int subwrite(int, void *, int);
 
 #endif
diff -ruN qmail-1.03-orig/received.c qmail-1.03-ldap-20060201-orig/received.c
--- qmail-1.03-orig/received.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/received.c	2006-02-25 11:00:56.000000000 +0100
@@ -15,6 +15,10 @@
   if (ch == '=') return 1;
   if (ch == ':') return 1;
   if (ch == '-') return 1;
+  if (ch == '_') return 1;
+  if (ch == '#') return 1;
+  if (ch == ']') return 1;
+  if (ch == '[') return 1;
   if ((ch >= 'a') && (ch <= 'z')) return 1;
   if ((ch >= 'A') && (ch <= 'Z')) return 1;
   if ((ch >= '0') && (ch <= '9')) return 1;
@@ -23,10 +27,10 @@
 
 void safeput(qqt,s)
 struct qmail *qqt;
-char *s;
+const char *s;
 {
   char ch;
-  while (ch = *s++) {
+  while ((ch = *s++)) {
     if (!issafe(ch)) ch = '?';
     qmail_put(qqt,&ch,1);
   }
@@ -37,14 +41,17 @@
 /* "Received: from relay1.uu.net (HELO uunet.uu.net) (7@192.48.96.5)\n" */
 /* "  by silverton.berkeley.edu with SMTP; 26 Sep 1995 04:46:54 -0000\n" */
 
-void received(qqt,protocol,local,remoteip,remotehost,remoteinfo,helo)
+void 
+received(qqt,protocol,local,remoteip,remotehost,remoteinfo,helo,mailfrom,rcptto)
 struct qmail *qqt;
-char *protocol;
-char *local;
-char *remoteip;
-char *remotehost;
-char *remoteinfo;
-char *helo;
+const char *protocol;
+const char *local;
+const char *remoteip;
+const char *remotehost;
+const char *remoteinfo;
+const char *helo;
+const char *mailfrom;
+const char *rcptto;
 {
   struct datetime dt;
 
@@ -60,12 +67,29 @@
     safeput(qqt,remoteinfo);
     qmail_puts(qqt,"@");
   }
+  qmail_puts(qqt,"[");
   safeput(qqt,remoteip);
-  qmail_puts(qqt,")\n  by ");
+  qmail_puts(qqt,"])");
+
+  if (mailfrom) {
+    qmail_puts(qqt,"\n          (envelope-sender <");
+    safeput(qqt,mailfrom);
+    qmail_puts(qqt,">)");
+  }
+  qmail_puts(qqt,"\n          by ");
+
   safeput(qqt,local);
-  qmail_puts(qqt," with ");
+  qmail_puts(qqt," (qmail-ldap-1.03) with ");
   qmail_puts(qqt,protocol);
+
+  if (rcptto) {
+    qmail_puts(qqt,"\n          for <");
+    safeput(qqt,rcptto);
+    qmail_puts(qqt,">");
+  }
   qmail_puts(qqt,"; ");
+  
   datetime_tai(&dt,now());
   qmail_put(qqt,buf,date822fmt(buf,&dt));
 }
+
diff -ruN qmail-1.03-orig/received.h qmail-1.03-ldap-20060201-orig/received.h
--- qmail-1.03-orig/received.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/received.h	2006-02-25 11:00:56.000000000 +0100
@@ -1,6 +1,9 @@
 #ifndef RECEIVED_H
 #define RECEIVED_H
 
-extern void received();
+#include "qmail.h"
+
+extern void received(struct qmail *, const char *, const char *, const char *,
+    const char *, const char *, const char *, const char *, const char *);
 
 #endif
diff -ruN qmail-1.03-orig/remoteinfo.c qmail-1.03-ldap-20060201-orig/remoteinfo.c
--- qmail-1.03-orig/remoteinfo.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/remoteinfo.c	2006-02-25 11:00:56.000000000 +0100
@@ -2,6 +2,7 @@
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <fcntl.h>
+#include <unistd.h>
 #include "byte.h"
 #include "substdio.h"
 #include "ip.h"
@@ -32,7 +33,6 @@
 {
   char *x;
   int s;
-  struct sockaddr_in sin;
   substdio ss;
   char buf[32];
   unsigned int len;
@@ -44,12 +44,7 @@
   s = socket(AF_INET,SOCK_STREAM,0);
   if (s == -1) return 0;
  
-  byte_zero(&sin,sizeof(sin));
-  sin.sin_family = AF_INET;
-  byte_copy(&sin.sin_addr,4,ipl);
-  sin.sin_port = 0;
-  if (bind(s,(struct sockaddr *) &sin,sizeof(sin)) == -1) { close(s); return 0; }
-  if (timeoutconn(s,ipr,113,timeout) == -1) { close(s); return 0; }
+  if (timeoutconn(s,ipr,ipl,113,timeout) == -1) { close(s); return 0; }
   fcntl(s,F_SETFL,fcntl(s,F_GETFL,0) & ~O_NDELAY);
  
   len = 0;
diff -ruN qmail-1.03-orig/remoteinfo.h qmail-1.03-ldap-20060201-orig/remoteinfo.h
--- qmail-1.03-orig/remoteinfo.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/remoteinfo.h	2006-02-25 11:00:56.000000000 +0100
@@ -1,6 +1,9 @@
 #ifndef REMOTEINFO_H
 #define REMOTEINFO_H
 
-extern char *remoteinfo_get();
+struct ip_address;
+
+extern char *remoteinfo_get(struct  ip_address *, unsigned long,
+    struct ip_address *, unsigned long, int);
 
 #endif
diff -ruN qmail-1.03-orig/scan_8long.c qmail-1.03-ldap-20060201-orig/scan_8long.c
--- qmail-1.03-orig/scan_8long.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/scan_8long.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,6 +1,6 @@
 #include "scan.h"
 
-unsigned int scan_8long(s,u) register char *s; register unsigned long *u;
+unsigned int scan_8long(s,u) register const char *s; register unsigned long *u;
 {
   register unsigned int pos; register unsigned long result;
   register unsigned long c;
diff -ruN qmail-1.03-orig/scan.h qmail-1.03-ldap-20060201-orig/scan.h
--- qmail-1.03-orig/scan.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/scan.h	2006-02-25 11:00:56.000000000 +0100
@@ -1,16 +1,22 @@
 #ifndef SCAN_H
 #define SCAN_H
 
+/* XXX not available in qmail-1.03
 extern unsigned int scan_uint();
 extern unsigned int scan_xint();
 extern unsigned int scan_nbbint();
 extern unsigned int scan_ushort();
 extern unsigned int scan_xshort();
 extern unsigned int scan_nbbshort();
-extern unsigned int scan_ulong();
+*/
+extern unsigned int scan_ulong(const char *, unsigned long *);
+/* XXX not available in qmail-1.03
 extern unsigned int scan_xlong();
 extern unsigned int scan_nbblong();
+*/
+extern unsigned int scan_8long(const char *, unsigned long *);
 
+/* XXX not available in qmail-1.03
 extern unsigned int scan_plusminus();
 extern unsigned int scan_0x();
 
@@ -23,5 +29,6 @@
 extern unsigned int scan_memcmp();
 
 extern unsigned int scan_long();
+*/
 
 #endif
diff -ruN qmail-1.03-orig/scan_ulong.c qmail-1.03-ldap-20060201-orig/scan_ulong.c
--- qmail-1.03-orig/scan_ulong.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/scan_ulong.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,6 +1,6 @@
 #include "scan.h"
 
-unsigned int scan_ulong(s,u) register char *s; register unsigned long *u;
+unsigned int scan_ulong(s,u) register const char *s; register unsigned long *u;
 {
   register unsigned int pos; register unsigned long result;
   register unsigned long c;
diff -ruN qmail-1.03-orig/seek_cur.c qmail-1.03-ldap-20060201-orig/seek_cur.c
--- qmail-1.03-orig/seek_cur.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/seek_cur.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,4 +1,5 @@
 #include <sys/types.h>
+#include <unistd.h>
 #include "seek.h"
 
 #define CUR 1 /* sigh */
diff -ruN qmail-1.03-orig/seek_end.c qmail-1.03-ldap-20060201-orig/seek_end.c
--- qmail-1.03-orig/seek_end.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/seek_end.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,4 +1,5 @@
 #include <sys/types.h>
+#include <unistd.h>
 #include "seek.h"
 
 #define END 2 /* sigh */
diff -ruN qmail-1.03-orig/seek.h qmail-1.03-ldap-20060201-orig/seek.h
--- qmail-1.03-orig/seek.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/seek.h	2006-02-25 11:00:56.000000000 +0100
@@ -3,12 +3,12 @@
 
 typedef unsigned long seek_pos;
 
-extern seek_pos seek_cur();
+extern seek_pos seek_cur(int fd);
 
-extern int seek_set();
-extern int seek_end();
+extern int seek_set(int fd, seek_pos);
+extern int seek_end(int fd);
 
-extern int seek_trunc();
+extern int seek_trunc(int fd, seek_pos);
 
 #define seek_begin(fd) (seek_set((fd),(seek_pos) 0))
 
diff -ruN qmail-1.03-orig/seek_set.c qmail-1.03-ldap-20060201-orig/seek_set.c
--- qmail-1.03-orig/seek_set.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/seek_set.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,4 +1,5 @@
 #include <sys/types.h>
+#include <unistd.h>
 #include "seek.h"
 
 #define SET 0 /* sigh */
diff -ruN qmail-1.03-orig/seek_trunc.c qmail-1.03-ldap-20060201-orig/seek_trunc.c
--- qmail-1.03-orig/seek_trunc.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/seek_trunc.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,4 +1,5 @@
 #include <sys/types.h>
+#include <unistd.h>
 #include "seek.h"
 
 int seek_trunc(fd,pos) int fd; seek_pos pos;
diff -ruN qmail-1.03-orig/select.h2 qmail-1.03-ldap-20060201-orig/select.h2
--- qmail-1.03-orig/select.h2	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/select.h2	2006-02-25 11:00:56.000000000 +0100
@@ -4,6 +4,7 @@
 #include <sys/types.h>
 #include <sys/time.h>
 #include <sys/select.h>
+#include <string.h> /* OpenBSD needs this for FD_ZERO */
 extern int select();
 
 #endif
diff -ruN qmail-1.03-orig/sendmail.c qmail-1.03-ldap-20060201-orig/sendmail.c
--- qmail-1.03-orig/sendmail.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/sendmail.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "sgetopt.h"
 #include "substdio.h"
 #include "subfd.h"
@@ -19,7 +20,7 @@
   _exit(100);
 }
 
-char *smtpdarg[] = { "bin/qmail-smtpd", 0 };
+const char *smtpdarg[] = { "bin/qmail-smtpd", 0 };
 void smtpd()
 {
   if (!env_get("PROTO")) {
@@ -32,29 +33,61 @@
     if (!env_put("TCPREMOTEHOST=localhost")) nomem();
     if (!env_put("TCPREMOTEINFO=sendmail-bs")) nomem();
   }
-  execv(*smtpdarg,smtpdarg);
+  execv(*smtpdarg,(char **)smtpdarg);
   substdio_putsflush(subfderr,"sendmail: fatal: unable to run qmail-smtpd\n");
   _exit(111);
 }
 
-char *qreadarg[] = { "bin/qmail-qread", 0 };
+const char *qreadarg[] = { "bin/qmail-qread", 0 };
 void mailq()
 {
-  execv(*qreadarg,qreadarg);
+  execv(*qreadarg,(char **)qreadarg);
   substdio_putsflush(subfderr,"sendmail: fatal: unable to run qmail-qread\n");
   _exit(111);
 }
 
+void do_sender(s)
+const char *s;
+{
+  char *x;
+  unsigned int n;
+  unsigned int a;
+  unsigned int i;
+  
+  env_unset("QMAILNAME");
+  env_unset("MAILNAME");
+  env_unset("NAME");
+  env_unset("QMAILHOST");
+  env_unset("MAILHOST");
+
+  n = str_len(s);
+  a = str_rchr(s, '@');
+  if (a == n)
+  {
+    env_put2("QMAILUSER", s);
+    return;
+  }
+  env_put2("QMAILHOST", s + a + 1);
+
+  x = alloc((a + 1) * sizeof(char));
+  if (!x) nomem();
+  for (i = 0; i < a; i++)
+    x[i] = s[i];
+  x[i] = 0;
+  env_put2("QMAILUSER", x);
+  alloc_free(x);
+}
+
 int flagh;
 char *sender;
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
   int opt;
-  char **qiargv;
-  char **arg;
+  const char **qiargv;
+  const char **arg;
   int i;
  
   if (chdir(auto_qmail) == -1) {
@@ -109,7 +142,7 @@
     _exit(100);
   }
 
-  qiargv = (char **) alloc((argc + 10) * sizeof(char *));
+  qiargv = (const char **) alloc((argc + 10) * sizeof(char *));
   if (!qiargv) nomem();
  
   arg = qiargv;
@@ -118,12 +151,13 @@
   if (sender) {
     *arg++ = "-f";
     *arg++ = sender;
+    do_sender(sender);
   }
   *arg++ = "--";
   for (i = 0;i < argc;++i) *arg++ = argv[i];
   *arg = 0;
  
-  execv(*qiargv,qiargv);
+  execv(*qiargv,(char **)qiargv);
   substdio_putsflush(subfderr,"sendmail: fatal: unable to run qmail-inject\n");
-  _exit(111);
+  return 111;
 }
diff -ruN qmail-1.03-orig/sgetopt.c qmail-1.03-ldap-20060201-orig/sgetopt.c
--- qmail-1.03-orig/sgetopt.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/sgetopt.c	2006-02-25 11:00:56.000000000 +0100
@@ -23,15 +23,15 @@
 #define optprogname sgetoptprogname
 
 int opterr = 1;
-char *optprogname = 0;
+const char *optprogname = 0;
 
 int getopt(argc,argv,opts)
 int argc;
 char **argv;
-char *opts;
+const char *opts;
 {
   int c;
-  char *s;
+  const char *s;
 
   if (!optprogname) {
     optprogname = *argv;
diff -ruN qmail-1.03-orig/sgetopt.h qmail-1.03-ldap-20060201-orig/sgetopt.h
--- qmail-1.03-orig/sgetopt.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/sgetopt.h	2006-02-25 11:00:56.000000000 +0100
@@ -14,8 +14,8 @@
 
 #include "subgetopt.h"
 
-extern int sgetoptmine();
+extern int sgetoptmine(int, char **, const char *);
 extern int sgetopterr;
-extern char *sgetoptprogname;
+extern const char *sgetoptprogname;
 
 #endif
diff -ruN qmail-1.03-orig/sig_alarm.c qmail-1.03-ldap-20060201-orig/sig_alarm.c
--- qmail-1.03-orig/sig_alarm.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/sig_alarm.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,7 +1,7 @@
 #include <signal.h>
 #include "sig.h"
 
-void sig_alarmblock() { sig_block(SIGALRM); }
-void sig_alarmunblock() { sig_unblock(SIGALRM); }
+void sig_alarmblock(void) { sig_block(SIGALRM); }
+void sig_alarmunblock(void) { sig_unblock(SIGALRM); }
 void sig_alarmcatch(f) void (*f)(); { sig_catch(SIGALRM,f); }
-void sig_alarmdefault() { sig_catch(SIGALRM,SIG_DFL); }
+void sig_alarmdefault(void) { sig_catch(SIGALRM,SIG_DFL); }
diff -ruN qmail-1.03-orig/sig_block.c qmail-1.03-ldap-20060201-orig/sig_block.c
--- qmail-1.03-orig/sig_block.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/sig_block.c	2006-02-25 11:00:56.000000000 +0100
@@ -28,7 +28,7 @@
 #endif
 }
 
-void sig_blocknone()
+void sig_blocknone(void)
 {
 #ifdef HASSIGPROCMASK
   sigset_t ss;
diff -ruN qmail-1.03-orig/sig_child.c qmail-1.03-ldap-20060201-orig/sig_child.c
--- qmail-1.03-orig/sig_child.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/sig_child.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,7 +1,7 @@
 #include <signal.h>
 #include "sig.h"
 
-void sig_childblock() { sig_block(SIGCHLD); }
-void sig_childunblock() { sig_unblock(SIGCHLD); }
+void sig_childblock(void) { sig_block(SIGCHLD); }
+void sig_childunblock(void) { sig_unblock(SIGCHLD); }
 void sig_childcatch(f) void (*f)(); { sig_catch(SIGCHLD,f); }
-void sig_childdefault() { sig_catch(SIGCHLD,SIG_DFL); }
+void sig_childdefault(void) { sig_catch(SIGCHLD,SIG_DFL); }
diff -ruN qmail-1.03-orig/sig.h qmail-1.03-ldap-20060201-orig/sig.h
--- qmail-1.03-orig/sig.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/sig.h	2006-02-25 11:00:56.000000000 +0100
@@ -1,43 +1,45 @@
 #ifndef SIG_H
 #define SIG_H
 
-extern void sig_catch();
-extern void sig_block();
-extern void sig_unblock();
-extern void sig_blocknone();
-extern void sig_pause();
+extern void sig_catch(int, void (*)());
+extern void sig_block(int);
+extern void sig_unblock(int);
+extern void sig_blocknone(void);
+extern void sig_pause(void);
 
 extern void sig_dfl();
 
-extern void sig_miscignore();
-extern void sig_bugcatch();
+extern void sig_miscignore(void);
+extern void sig_bugcatch(void (*)());
 
-extern void sig_pipeignore();
-extern void sig_pipedefault();
+extern void sig_pipeignore(void);
+extern void sig_pipedefault(void);
 
+/* XXX not available in qmail-1.03
 extern void sig_contblock();
 extern void sig_contunblock();
 extern void sig_contcatch();
 extern void sig_contdefault();
+*/
 
-extern void sig_termblock();
-extern void sig_termunblock();
-extern void sig_termcatch();
-extern void sig_termdefault();
-
-extern void sig_alarmblock();
-extern void sig_alarmunblock();
-extern void sig_alarmcatch();
-extern void sig_alarmdefault();
-
-extern void sig_childblock();
-extern void sig_childunblock();
-extern void sig_childcatch();
-extern void sig_childdefault();
-
-extern void sig_hangupblock();
-extern void sig_hangupunblock();
-extern void sig_hangupcatch();
-extern void sig_hangupdefault();
+extern void sig_termblock(void);
+extern void sig_termunblock(void);
+extern void sig_termcatch(void (*)());
+extern void sig_termdefault(void);
+
+extern void sig_alarmblock(void);
+extern void sig_alarmunblock(void);
+extern void sig_alarmcatch(void (*)());
+extern void sig_alarmdefault(void);
+
+extern void sig_childblock(void);
+extern void sig_childunblock(void);
+extern void sig_childcatch(void (*)());
+extern void sig_childdefault(void);
+
+extern void sig_hangupblock(void);
+extern void sig_hangupunblock(void);
+extern void sig_hangupcatch(void (*)());
+extern void sig_hangupdefault(void);
 
 #endif
diff -ruN qmail-1.03-orig/sig_hup.c qmail-1.03-ldap-20060201-orig/sig_hup.c
--- qmail-1.03-orig/sig_hup.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/sig_hup.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,7 +1,7 @@
 #include <signal.h>
 #include "sig.h"
 
-void sig_hangupblock() { sig_block(SIGHUP); }
-void sig_hangupunblock() { sig_unblock(SIGHUP); }
+void sig_hangupblock(void) { sig_block(SIGHUP); }
+void sig_hangupunblock(void) { sig_unblock(SIGHUP); }
 void sig_hangupcatch(f) void (*f)(); { sig_catch(SIGHUP,f); }
-void sig_hangupdefault() { sig_catch(SIGHUP,SIG_DFL); }
+void sig_hangupdefault(void) { sig_catch(SIGHUP,SIG_DFL); }
diff -ruN qmail-1.03-orig/sig_misc.c qmail-1.03-ldap-20060201-orig/sig_misc.c
--- qmail-1.03-orig/sig_misc.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/sig_misc.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,7 +1,7 @@
 #include <signal.h>
 #include "sig.h"
 
-void sig_miscignore()
+void sig_miscignore(void)
 {
   sig_catch(SIGVTALRM,SIG_IGN);
   sig_catch(SIGPROF,SIG_IGN);
diff -ruN qmail-1.03-orig/signatures qmail-1.03-ldap-20060201-orig/signatures
--- qmail-1.03-orig/signatures	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/signatures	2006-02-25 11:00:56.000000000 +0100
@@ -0,0 +1,66 @@
+# Windows executables seen in active virii
+TVqQAAMAA
+TVpQAAIAA
+TVoAAAEAA
+TVoAACQAA
+TVqQAAMAA
+TVoAAD8AA
+# Additional windows executable signatures not yet seen in virii
+TVpAALQAc
+TVpyAXkAX
+TVrmAU4AA
+TVrhARwAk
+TVoFAQUAA
+TVoAAAQAA
+TVoIARMAA
+TVouARsAA
+TVrQAT8AA
+# .GIF file found in the current fake Microsoft patch virus making the rounds.
+R0lGODlhaAA7APcAAP///+rp6puSp6GZrDUjUUc6Zn53mFJMdbGvvVtXh2xre8bF1x8cU4yLprOy
+
+# .ZIPfile signature seen in SoBig.E:
+# This signature is to generic and blocks valid zip files so disable it.
+#UEsDBBQAA
+
+# .ZIPfile signature of MyDoom:
+# nota bene * is a anymatch.
+UEsDBAoAAAAAA*****DKJx+eAFgAAABYAA**AAAA
+# .ZIPfile signatures of Beagle and friends:
+UEsDBAoAAQAAA*****Cf4kJRDDAAAAAwAAA*AAAA
+UEsDBAoAAQAAAi****Bcl5T9DzAAAAMwAAA*AAAA
+UEsDBAoAAAAAA*****CxG9oCAH4AAAB+AA**AAAA
+UEsDBAoAAAAAA*****BiZMYWCWMAAAljAAA*AAAA
+UEsDBAoAAAAAA******jiB3egHMAAIBzAAB*AAAA
+UEsDBAoAAQAAA******D+JTDGqkIAA6pCAA*AAAA
+UEsDBAoAAAAAA*****B+cADhaG0AAGhtAAB*AAAA
+UEsDBAoAAAAAA*****BdbrAiAFYAAABWAAA*AAAA
+UEsDBAoAAAAAA******FWheeAPQBAAD0AQ**AAAA
+UEsDBAoAAAAAA*****GpXle1AOABAADgAQA*AAAA
+UEsDBAoAAAAAA*****AnDhYmfXMAAH1zAABwAAAA
+UEsDBAoAAQAIA*****AZRqEfZFEAACROAAAMAAAA
+UEsDBAoAAQAIA*****DJkv0Bq1QAAAxRAAANAAAA
+UEsDBAoAAQAAA*****AZ45yiDFMAAABTAAAKAAAA
+UEsDBAoAAQAAA*****AOGOjBMVMAACVTAAANAAAA
+UEsDBAoAAAAAAAFYrj******/cEAAP3BAAAfAAAA
+UEsDBAoAAAAAA*****C93UuYwHAAAMBwAADXAAAA
+UEsDBAoAAQAAA*****DUdqQ1v1QAALNUAAAKAAAA
+UEsDBAoAAQAAA*****EsQ5lqlnsEAIp7BAAMAAAA
+UEsDBAoAAQAAA*****Epm2uEYuoAAFbqAAAJAAAA
+UEsDBAoAAQAAA*****HelFoJ1eUBAMnlAQAKAAAA
+UEsDBAoAAAAAA*****AjTTDoAIAAAACAAACjAAAA
+UEsDBAoAAAAAA*****BCNPQYAPwBAAD8AQAHAAAA
+UEsDBAoAAAAAA*****FZUaXpAHwAAAB8AABUAAAA
+UEsDBAoAAAAAA*****FxKYToA34AAAN+AABXAAAA
+UEsDBAoAAAAAA*****EAAAAAAAAAAAAAAAAFAAAA
+UEsDBBQAAAAIA*****FhTJoyVgAAAG8AAAAIAAAA
+UEsDBAoAAAAAA*****CHcNZsANAAAADQAAC*AAAA
+UEsDBAoAAAAAA*****H7vMVGA38AAAN/AABUAAAA
+UEsDBAoAAAAAA*****FbiToH6N0AAOjdAABPAAAA
+UEsDBAoAAAAAA***VzFZUaXpAHwAAAB8AAB*AAAA
+UEsDBAoAAAAAA****TFUnOUjAHoAAAB6AAA*AAAA
+
+# strange .hta virus I got
+PEhUTUw+DQo8SEVBRD4NCjxUSVRMRT5XaW5kb3dz
+# ... and a .vbs virus
+ZGltIGZpbGVzeXMsIGZpbGV0eHQsIGdldG5hbWUs
+
diff -ruN qmail-1.03-orig/sig_pause.c qmail-1.03-ldap-20060201-orig/sig_pause.c
--- qmail-1.03-orig/sig_pause.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/sig_pause.c	2006-02-25 11:00:56.000000000 +0100
@@ -2,7 +2,7 @@
 #include "sig.h"
 #include "hassgprm.h"
 
-void sig_pause()
+void sig_pause(void)
 {
 #ifdef HASSIGPROCMASK
   sigset_t ss;
diff -ruN qmail-1.03-orig/sig_pipe.c qmail-1.03-ldap-20060201-orig/sig_pipe.c
--- qmail-1.03-orig/sig_pipe.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/sig_pipe.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,5 +1,5 @@
 #include <signal.h>
 #include "sig.h"
 
-void sig_pipeignore() { sig_catch(SIGPIPE,SIG_IGN); }
-void sig_pipedefault() { sig_catch(SIGPIPE,SIG_DFL); }
+void sig_pipeignore(void) { sig_catch(SIGPIPE,SIG_IGN); }
+void sig_pipedefault(void) { sig_catch(SIGPIPE,SIG_DFL); }
diff -ruN qmail-1.03-orig/sig_term.c qmail-1.03-ldap-20060201-orig/sig_term.c
--- qmail-1.03-orig/sig_term.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/sig_term.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,7 +1,7 @@
 #include <signal.h>
 #include "sig.h"
 
-void sig_termblock() { sig_block(SIGTERM); }
-void sig_termunblock() { sig_unblock(SIGTERM); }
+void sig_termblock(void) { sig_block(SIGTERM); }
+void sig_termunblock(void) { sig_unblock(SIGTERM); }
 void sig_termcatch(f) void (*f)(); { sig_catch(SIGTERM,f); }
-void sig_termdefault() { sig_catch(SIGTERM,SIG_DFL); }
+void sig_termdefault(void) { sig_catch(SIGTERM,SIG_DFL); }
diff -ruN qmail-1.03-orig/slurpclose.c qmail-1.03-ldap-20060201-orig/slurpclose.c
--- qmail-1.03-orig/slurpclose.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/slurpclose.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "stralloc.h"
 #include "readwrite.h"
 #include "slurpclose.h"
@@ -6,7 +7,7 @@
 int slurpclose(fd,sa,bufsize)
 int fd;
 stralloc *sa;
-int bufsize;
+unsigned int bufsize;
 {
   int r;
   for (;;) {
diff -ruN qmail-1.03-orig/slurpclose.h qmail-1.03-ldap-20060201-orig/slurpclose.h
--- qmail-1.03-orig/slurpclose.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/slurpclose.h	2006-02-25 11:00:56.000000000 +0100
@@ -1,6 +1,8 @@
 #ifndef SLURPCLOSE_H
 #define SLURPCLOSE_H
 
-extern int slurpclose();
+#include "stralloc.h"
+
+extern int slurpclose(int, stralloc *, unsigned int);
 
 #endif
